package com.alxad.alx.demo;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import com.alxad.AppConfig;
import com.alxad.R;
import com.alxad.api.AlxBannerAD;
import com.alxad.api.AlxBannerADListener;

public class AlxBannerDemoActivity extends AppCompatActivity implements View.OnClickListener {
    private final String TAG = "AlxBannerDemoActivity";
    private AlxBannerAD alxBannerAD;
    //    private TextView mTvTitle;
    private Button mBnLoad;
    private Button mBnShow;
    private TextView mTvTip;
    private Button mBnLoadAndShow;
    private int adSize;
    private FrameLayout mAdContainer;
    private AlxBannerAD mAlxBannerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_alx_banner_demo);
        if (getIntent() != null) {
            adSize = getIntent().getIntExtra("adsize", 0);
        }
        AlxBannerAD.AlxAdSize alxAdSize = adSize == 0 ? AlxBannerAD.AlxAdSize.SIZE_320_50 :
                adSize == 1 ? AlxBannerAD.AlxAdSize.SIZE_300_250 :
                        AlxBannerAD.AlxAdSize.SIZE_320_480;
        Log.d(TAG, "adsize : " + alxAdSize);
        setTitle("BannerAd  w_h:  " + alxAdSize);

//        mTvTitle = findViewById(R.id.tv_title);
        mTvTip = (TextView) findViewById(R.id.tv_tip);
        mBnLoad = (Button) findViewById(R.id.bn_load);
        mBnShow = (Button) findViewById(R.id.bn_show);
        mBnLoadAndShow = (Button) findViewById(R.id.bn_load_show);
        mAdContainer = (FrameLayout) findViewById(R.id.ad_container);
        mAlxBannerView = (AlxBannerAD) findViewById(R.id.do_ad_banner);

        mBnLoad.setOnClickListener(this);
        mBnShow.setOnClickListener(this);
        mBnLoadAndShow.setOnClickListener(this);
        mBnShow.setEnabled(false);
//        mTvTitle.setText("w_h:  " + alxAdSize);
//
    }

    @Override
    protected void onDestroy() {
        if (alxBannerAD != null) {
            alxBannerAD.destory();
        }
        if (mAlxBannerView != null) {
            mAlxBannerView.destory();
        }
        super.onDestroy();
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bn_load:
                bnPreLoad();
                break;
            case R.id.bn_show:
                bnShow();
                break;
            case R.id.bn_load_show:
                bnLoadAndShow();
                break;
        }
    }

    private void bnPreLoad() {
        mBnLoad.setEnabled(false);
        alxBannerAD = new AlxBannerAD(this);
        AlxBannerAD.AlxAdSize alxAdSize = adSize == 0 ? AlxBannerAD.AlxAdSize.SIZE_320_50 :
                adSize == 1 ? AlxBannerAD.AlxAdSize.SIZE_300_250 :
                        AlxBannerAD.AlxAdSize.SIZE_320_480;
        alxBannerAD.setCanClosed(false);
        alxBannerAD.preLoad(this, AppConfig.ALX_BANNER_AD_PID, new AlxBannerADListener() {
            @Override
            public void onAdLoaded(AlxBannerAD banner) {
                Log.d(TAG, "onAdLoaded 横幅加载成功:" + Thread.currentThread().getName());
                mTvTip.setText("AlxBannerAD 横幅预加载成功");
                mBnShow.setEnabled(true);
                mBnLoad.setEnabled(true);
            }

            @Override
            public void onAdError(AlxBannerAD banner, int errorCode, String errorMsg) {
                mBnShow.setEnabled(false);
                mBnLoad.setEnabled(true);
                mTvTip.setText("AlxBannerAD 横幅预加载失败");
                Log.d(TAG, "onAdError 横幅加载失败  errorMsg:" + errorMsg + "  errorCode:" + errorCode + ":" + Thread.currentThread().getName());
            }

            @Override
            public void onAdClicked(AlxBannerAD banner) {
                Log.d(TAG, "onAdClicked 横幅点击成功");
            }

            @Override
            public void onAdShow(AlxBannerAD banner) {
                Log.d(TAG, "onAdShow 横幅展示成功");
            }

            @Override
            public void onAdClose() {
                Log.d(TAG, "onAdClose");
            }
        }, alxAdSize);
    }

    private void bnShow() {
        if (alxBannerAD != null && alxBannerAD.isReady()) {
            alxBannerAD.showAd(mAdContainer);
            mTvTip.setText("");
        }
    }

    private void bnLoadAndShow() {
        AlxBannerAD.AlxAdSize alxAdSize = adSize == 0 ? AlxBannerAD.AlxAdSize.SIZE_320_50 :
                adSize == 1 ? AlxBannerAD.AlxAdSize.SIZE_300_250 :
                        AlxBannerAD.AlxAdSize.SIZE_320_480;
        mAlxBannerView.setVisibility(View.VISIBLE);
        mAlxBannerView.setCanClosed(true);
        mAlxBannerView.load(this, AppConfig.ALX_BANNER_AD_PID, new AlxBannerADListener() {
            @Override
            public void onAdLoaded(AlxBannerAD banner) {
                Log.d(TAG, "onAdLoaded 横幅加载成功");
            }

            @Override
            public void onAdError(AlxBannerAD banner, int errorCode, String errorMsg) {
                Log.d(TAG, "onAdError 横幅加载失败  errorMsg:" + errorMsg + "  errorCode:" + errorCode);
            }

            @Override
            public void onAdClicked(AlxBannerAD banner) {
                Log.d(TAG, "onAdClicked 横幅点击成功");
            }

            @Override
            public void onAdShow(AlxBannerAD banner) {
                Log.d(TAG, "onAdShow 横幅展示成功");
            }

            @Override
            public void onAdClose() {
                Log.d(TAG, "onAdClose");
            }
        }, alxAdSize);
    }
}